# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.  # noqa: E501

    OpenAPI spec version: v2.1
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class ConnectLog(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account_id': 'str',
        'config_url': 'str',
        'connect_debug_log': 'list[ConnectDebugLog]',
        'connect_id': 'str',
        'created': 'str',
        'email': 'str',
        'envelope_id': 'str',
        'error': 'str',
        'failure_id': 'str',
        'failure_uri': 'str',
        'last_try': 'str',
        'log_id': 'str',
        'log_uri': 'str',
        'retry_count': 'str',
        'retry_uri': 'str',
        'status': 'str',
        'subject': 'str',
        'user_name': 'str'
    }

    attribute_map = {
        'account_id': 'accountId',
        'config_url': 'configUrl',
        'connect_debug_log': 'connectDebugLog',
        'connect_id': 'connectId',
        'created': 'created',
        'email': 'email',
        'envelope_id': 'envelopeId',
        'error': 'error',
        'failure_id': 'failureId',
        'failure_uri': 'failureUri',
        'last_try': 'lastTry',
        'log_id': 'logId',
        'log_uri': 'logUri',
        'retry_count': 'retryCount',
        'retry_uri': 'retryUri',
        'status': 'status',
        'subject': 'subject',
        'user_name': 'userName'
    }

    def __init__(self, account_id=None, config_url=None, connect_debug_log=None, connect_id=None, created=None, email=None, envelope_id=None, error=None, failure_id=None, failure_uri=None, last_try=None, log_id=None, log_uri=None, retry_count=None, retry_uri=None, status=None, subject=None, user_name=None):  # noqa: E501
        """ConnectLog - a model defined in Swagger"""  # noqa: E501

        self._account_id = None
        self._config_url = None
        self._connect_debug_log = None
        self._connect_id = None
        self._created = None
        self._email = None
        self._envelope_id = None
        self._error = None
        self._failure_id = None
        self._failure_uri = None
        self._last_try = None
        self._log_id = None
        self._log_uri = None
        self._retry_count = None
        self._retry_uri = None
        self._status = None
        self._subject = None
        self._user_name = None
        self.discriminator = None

        if account_id is not None:
            self.account_id = account_id
        if config_url is not None:
            self.config_url = config_url
        if connect_debug_log is not None:
            self.connect_debug_log = connect_debug_log
        if connect_id is not None:
            self.connect_id = connect_id
        if created is not None:
            self.created = created
        if email is not None:
            self.email = email
        if envelope_id is not None:
            self.envelope_id = envelope_id
        if error is not None:
            self.error = error
        if failure_id is not None:
            self.failure_id = failure_id
        if failure_uri is not None:
            self.failure_uri = failure_uri
        if last_try is not None:
            self.last_try = last_try
        if log_id is not None:
            self.log_id = log_id
        if log_uri is not None:
            self.log_uri = log_uri
        if retry_count is not None:
            self.retry_count = retry_count
        if retry_uri is not None:
            self.retry_uri = retry_uri
        if status is not None:
            self.status = status
        if subject is not None:
            self.subject = subject
        if user_name is not None:
            self.user_name = user_name

    @property
    def account_id(self):
        """Gets the account_id of this ConnectLog.  # noqa: E501

        The account ID associated with the envelope.  # noqa: E501

        :return: The account_id of this ConnectLog.  # noqa: E501
        :rtype: str
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this ConnectLog.

        The account ID associated with the envelope.  # noqa: E501

        :param account_id: The account_id of this ConnectLog.  # noqa: E501
        :type: str
        """

        self._account_id = account_id

    @property
    def config_url(self):
        """Gets the config_url of this ConnectLog.  # noqa: E501

        The web address of the listener or Retrieving Service end point for Connect.  # noqa: E501

        :return: The config_url of this ConnectLog.  # noqa: E501
        :rtype: str
        """
        return self._config_url

    @config_url.setter
    def config_url(self, config_url):
        """Sets the config_url of this ConnectLog.

        The web address of the listener or Retrieving Service end point for Connect.  # noqa: E501

        :param config_url: The config_url of this ConnectLog.  # noqa: E501
        :type: str
        """

        self._config_url = config_url

    @property
    def connect_debug_log(self):
        """Gets the connect_debug_log of this ConnectLog.  # noqa: E501

        A complex element containing information about the Connect configuration, error details, date/time, description and payload.  This is only included in the response if the query additional_info=true is used.  # noqa: E501

        :return: The connect_debug_log of this ConnectLog.  # noqa: E501
        :rtype: list[ConnectDebugLog]
        """
        return self._connect_debug_log

    @connect_debug_log.setter
    def connect_debug_log(self, connect_debug_log):
        """Sets the connect_debug_log of this ConnectLog.

        A complex element containing information about the Connect configuration, error details, date/time, description and payload.  This is only included in the response if the query additional_info=true is used.  # noqa: E501

        :param connect_debug_log: The connect_debug_log of this ConnectLog.  # noqa: E501
        :type: list[ConnectDebugLog]
        """

        self._connect_debug_log = connect_debug_log

    @property
    def connect_id(self):
        """Gets the connect_id of this ConnectLog.  # noqa: E501

        The identifier for the Connect configuration that failed. If an account has multiple Connect configurations, this value is used to look up the Connect configuration for the failed post.  # noqa: E501

        :return: The connect_id of this ConnectLog.  # noqa: E501
        :rtype: str
        """
        return self._connect_id

    @connect_id.setter
    def connect_id(self, connect_id):
        """Sets the connect_id of this ConnectLog.

        The identifier for the Connect configuration that failed. If an account has multiple Connect configurations, this value is used to look up the Connect configuration for the failed post.  # noqa: E501

        :param connect_id: The connect_id of this ConnectLog.  # noqa: E501
        :type: str
        """

        self._connect_id = connect_id

    @property
    def created(self):
        """Gets the created of this ConnectLog.  # noqa: E501

        The date and time the entry was created.  # noqa: E501

        :return: The created of this ConnectLog.  # noqa: E501
        :rtype: str
        """
        return self._created

    @created.setter
    def created(self, created):
        """Sets the created of this ConnectLog.

        The date and time the entry was created.  # noqa: E501

        :param created: The created of this ConnectLog.  # noqa: E501
        :type: str
        """

        self._created = created

    @property
    def email(self):
        """Gets the email of this ConnectLog.  # noqa: E501

        The email that sent the envelope.  # noqa: E501

        :return: The email of this ConnectLog.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this ConnectLog.

        The email that sent the envelope.  # noqa: E501

        :param email: The email of this ConnectLog.  # noqa: E501
        :type: str
        """

        self._email = email

    @property
    def envelope_id(self):
        """Gets the envelope_id of this ConnectLog.  # noqa: E501

        The envelope ID of the envelope status that failed to post.  # noqa: E501

        :return: The envelope_id of this ConnectLog.  # noqa: E501
        :rtype: str
        """
        return self._envelope_id

    @envelope_id.setter
    def envelope_id(self, envelope_id):
        """Sets the envelope_id of this ConnectLog.

        The envelope ID of the envelope status that failed to post.  # noqa: E501

        :param envelope_id: The envelope_id of this ConnectLog.  # noqa: E501
        :type: str
        """

        self._envelope_id = envelope_id

    @property
    def error(self):
        """Gets the error of this ConnectLog.  # noqa: E501

        The error that caused the Connect post to fail.  # noqa: E501

        :return: The error of this ConnectLog.  # noqa: E501
        :rtype: str
        """
        return self._error

    @error.setter
    def error(self, error):
        """Sets the error of this ConnectLog.

        The error that caused the Connect post to fail.  # noqa: E501

        :param error: The error of this ConnectLog.  # noqa: E501
        :type: str
        """

        self._error = error

    @property
    def failure_id(self):
        """Gets the failure_id of this ConnectLog.  # noqa: E501

        The failure log ID for the failure.  # noqa: E501

        :return: The failure_id of this ConnectLog.  # noqa: E501
        :rtype: str
        """
        return self._failure_id

    @failure_id.setter
    def failure_id(self, failure_id):
        """Sets the failure_id of this ConnectLog.

        The failure log ID for the failure.  # noqa: E501

        :param failure_id: The failure_id of this ConnectLog.  # noqa: E501
        :type: str
        """

        self._failure_id = failure_id

    @property
    def failure_uri(self):
        """Gets the failure_uri of this ConnectLog.  # noqa: E501

        The URI for the failure.  # noqa: E501

        :return: The failure_uri of this ConnectLog.  # noqa: E501
        :rtype: str
        """
        return self._failure_uri

    @failure_uri.setter
    def failure_uri(self, failure_uri):
        """Sets the failure_uri of this ConnectLog.

        The URI for the failure.  # noqa: E501

        :param failure_uri: The failure_uri of this ConnectLog.  # noqa: E501
        :type: str
        """

        self._failure_uri = failure_uri

    @property
    def last_try(self):
        """Gets the last_try of this ConnectLog.  # noqa: E501

        The date and time the last attempt to post.  # noqa: E501

        :return: The last_try of this ConnectLog.  # noqa: E501
        :rtype: str
        """
        return self._last_try

    @last_try.setter
    def last_try(self, last_try):
        """Sets the last_try of this ConnectLog.

        The date and time the last attempt to post.  # noqa: E501

        :param last_try: The last_try of this ConnectLog.  # noqa: E501
        :type: str
        """

        self._last_try = last_try

    @property
    def log_id(self):
        """Gets the log_id of this ConnectLog.  # noqa: E501

        The Connect log ID for the entry.  # noqa: E501

        :return: The log_id of this ConnectLog.  # noqa: E501
        :rtype: str
        """
        return self._log_id

    @log_id.setter
    def log_id(self, log_id):
        """Sets the log_id of this ConnectLog.

        The Connect log ID for the entry.  # noqa: E501

        :param log_id: The log_id of this ConnectLog.  # noqa: E501
        :type: str
        """

        self._log_id = log_id

    @property
    def log_uri(self):
        """Gets the log_uri of this ConnectLog.  # noqa: E501

        The URI for the log item.  # noqa: E501

        :return: The log_uri of this ConnectLog.  # noqa: E501
        :rtype: str
        """
        return self._log_uri

    @log_uri.setter
    def log_uri(self, log_uri):
        """Sets the log_uri of this ConnectLog.

        The URI for the log item.  # noqa: E501

        :param log_uri: The log_uri of this ConnectLog.  # noqa: E501
        :type: str
        """

        self._log_uri = log_uri

    @property
    def retry_count(self):
        """Gets the retry_count of this ConnectLog.  # noqa: E501

        The number of times the Connect post has been retried.  # noqa: E501

        :return: The retry_count of this ConnectLog.  # noqa: E501
        :rtype: str
        """
        return self._retry_count

    @retry_count.setter
    def retry_count(self, retry_count):
        """Sets the retry_count of this ConnectLog.

        The number of times the Connect post has been retried.  # noqa: E501

        :param retry_count: The retry_count of this ConnectLog.  # noqa: E501
        :type: str
        """

        self._retry_count = retry_count

    @property
    def retry_uri(self):
        """Gets the retry_uri of this ConnectLog.  # noqa: E501

        The UEI to retry to publish the Connect failure.  # noqa: E501

        :return: The retry_uri of this ConnectLog.  # noqa: E501
        :rtype: str
        """
        return self._retry_uri

    @retry_uri.setter
    def retry_uri(self, retry_uri):
        """Sets the retry_uri of this ConnectLog.

        The UEI to retry to publish the Connect failure.  # noqa: E501

        :param retry_uri: The retry_uri of this ConnectLog.  # noqa: E501
        :type: str
        """

        self._retry_uri = retry_uri

    @property
    def status(self):
        """Gets the status of this ConnectLog.  # noqa: E501

        The new envelope status for the failed Connect post. The possible values are: Any, Voided, Created, Deleted, Sent, Delivered, Signed, Completed, Declined, TimedOut, Template, or Processing.  # noqa: E501

        :return: The status of this ConnectLog.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this ConnectLog.

        The new envelope status for the failed Connect post. The possible values are: Any, Voided, Created, Deleted, Sent, Delivered, Signed, Completed, Declined, TimedOut, Template, or Processing.  # noqa: E501

        :param status: The status of this ConnectLog.  # noqa: E501
        :type: str
        """

        self._status = status

    @property
    def subject(self):
        """Gets the subject of this ConnectLog.  # noqa: E501

        The envelope subject.  # noqa: E501

        :return: The subject of this ConnectLog.  # noqa: E501
        :rtype: str
        """
        return self._subject

    @subject.setter
    def subject(self, subject):
        """Sets the subject of this ConnectLog.

        The envelope subject.  # noqa: E501

        :param subject: The subject of this ConnectLog.  # noqa: E501
        :type: str
        """

        self._subject = subject

    @property
    def user_name(self):
        """Gets the user_name of this ConnectLog.  # noqa: E501

        The name of the envelope sender.  # noqa: E501

        :return: The user_name of this ConnectLog.  # noqa: E501
        :rtype: str
        """
        return self._user_name

    @user_name.setter
    def user_name(self, user_name):
        """Sets the user_name of this ConnectLog.

        The name of the envelope sender.  # noqa: E501

        :param user_name: The user_name of this ConnectLog.  # noqa: E501
        :type: str
        """

        self._user_name = user_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ConnectLog, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ConnectLog):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
