# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.  # noqa: E501

    OpenAPI spec version: v2.1
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class Group(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'error_details': 'ErrorDetails',
        'group_id': 'str',
        'group_name': 'str',
        'group_type': 'str',
        'permission_profile_id': 'str',
        'users': 'list[UserInfo]',
        'users_count': 'str'
    }

    attribute_map = {
        'error_details': 'errorDetails',
        'group_id': 'groupId',
        'group_name': 'groupName',
        'group_type': 'groupType',
        'permission_profile_id': 'permissionProfileId',
        'users': 'users',
        'users_count': 'usersCount'
    }

    def __init__(self, error_details=None, group_id=None, group_name=None, group_type=None, permission_profile_id=None, users=None, users_count=None):  # noqa: E501
        """Group - a model defined in Swagger"""  # noqa: E501

        self._error_details = None
        self._group_id = None
        self._group_name = None
        self._group_type = None
        self._permission_profile_id = None
        self._users = None
        self._users_count = None
        self.discriminator = None

        if error_details is not None:
            self.error_details = error_details
        if group_id is not None:
            self.group_id = group_id
        if group_name is not None:
            self.group_name = group_name
        if group_type is not None:
            self.group_type = group_type
        if permission_profile_id is not None:
            self.permission_profile_id = permission_profile_id
        if users is not None:
            self.users = users
        if users_count is not None:
            self.users_count = users_count

    @property
    def error_details(self):
        """Gets the error_details of this Group.  # noqa: E501


        :return: The error_details of this Group.  # noqa: E501
        :rtype: ErrorDetails
        """
        return self._error_details

    @error_details.setter
    def error_details(self, error_details):
        """Sets the error_details of this Group.


        :param error_details: The error_details of this Group.  # noqa: E501
        :type: ErrorDetails
        """

        self._error_details = error_details

    @property
    def group_id(self):
        """Gets the group_id of this Group.  # noqa: E501

        The DocuSign group ID for the group.  # noqa: E501

        :return: The group_id of this Group.  # noqa: E501
        :rtype: str
        """
        return self._group_id

    @group_id.setter
    def group_id(self, group_id):
        """Sets the group_id of this Group.

        The DocuSign group ID for the group.  # noqa: E501

        :param group_id: The group_id of this Group.  # noqa: E501
        :type: str
        """

        self._group_id = group_id

    @property
    def group_name(self):
        """Gets the group_name of this Group.  # noqa: E501

        The name of the group.  # noqa: E501

        :return: The group_name of this Group.  # noqa: E501
        :rtype: str
        """
        return self._group_name

    @group_name.setter
    def group_name(self, group_name):
        """Sets the group_name of this Group.

        The name of the group.  # noqa: E501

        :param group_name: The group_name of this Group.  # noqa: E501
        :type: str
        """

        self._group_name = group_name

    @property
    def group_type(self):
        """Gets the group_type of this Group.  # noqa: E501

        The group type.  # noqa: E501

        :return: The group_type of this Group.  # noqa: E501
        :rtype: str
        """
        return self._group_type

    @group_type.setter
    def group_type(self, group_type):
        """Sets the group_type of this Group.

        The group type.  # noqa: E501

        :param group_type: The group_type of this Group.  # noqa: E501
        :type: str
        """

        self._group_type = group_type

    @property
    def permission_profile_id(self):
        """Gets the permission_profile_id of this Group.  # noqa: E501

        The ID of the permission profile associated with the group.  # noqa: E501

        :return: The permission_profile_id of this Group.  # noqa: E501
        :rtype: str
        """
        return self._permission_profile_id

    @permission_profile_id.setter
    def permission_profile_id(self, permission_profile_id):
        """Sets the permission_profile_id of this Group.

        The ID of the permission profile associated with the group.  # noqa: E501

        :param permission_profile_id: The permission_profile_id of this Group.  # noqa: E501
        :type: str
        """

        self._permission_profile_id = permission_profile_id

    @property
    def users(self):
        """Gets the users of this Group.  # noqa: E501

          # noqa: E501

        :return: The users of this Group.  # noqa: E501
        :rtype: list[UserInfo]
        """
        return self._users

    @users.setter
    def users(self, users):
        """Sets the users of this Group.

          # noqa: E501

        :param users: The users of this Group.  # noqa: E501
        :type: list[UserInfo]
        """

        self._users = users

    @property
    def users_count(self):
        """Gets the users_count of this Group.  # noqa: E501

          # noqa: E501

        :return: The users_count of this Group.  # noqa: E501
        :rtype: str
        """
        return self._users_count

    @users_count.setter
    def users_count(self, users_count):
        """Sets the users_count of this Group.

          # noqa: E501

        :param users_count: The users_count of this Group.  # noqa: E501
        :type: str
        """

        self._users_count = users_count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Group, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Group):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
