# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.  # noqa: E501

    OpenAPI spec version: v2.1
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class PowerFormFormDataEnvelope(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'envelope_id': 'str',
        'recipients': 'list[PowerFormFormDataRecipient]'
    }

    attribute_map = {
        'envelope_id': 'envelopeId',
        'recipients': 'recipients'
    }

    def __init__(self, envelope_id=None, recipients=None):  # noqa: E501
        """PowerFormFormDataEnvelope - a model defined in Swagger"""  # noqa: E501

        self._envelope_id = None
        self._recipients = None
        self.discriminator = None

        if envelope_id is not None:
            self.envelope_id = envelope_id
        if recipients is not None:
            self.recipients = recipients

    @property
    def envelope_id(self):
        """Gets the envelope_id of this PowerFormFormDataEnvelope.  # noqa: E501

        The envelope ID of the envelope status that failed to post.  # noqa: E501

        :return: The envelope_id of this PowerFormFormDataEnvelope.  # noqa: E501
        :rtype: str
        """
        return self._envelope_id

    @envelope_id.setter
    def envelope_id(self, envelope_id):
        """Sets the envelope_id of this PowerFormFormDataEnvelope.

        The envelope ID of the envelope status that failed to post.  # noqa: E501

        :param envelope_id: The envelope_id of this PowerFormFormDataEnvelope.  # noqa: E501
        :type: str
        """

        self._envelope_id = envelope_id

    @property
    def recipients(self):
        """Gets the recipients of this PowerFormFormDataEnvelope.  # noqa: E501

        An array of powerform recipients.  # noqa: E501

        :return: The recipients of this PowerFormFormDataEnvelope.  # noqa: E501
        :rtype: list[PowerFormFormDataRecipient]
        """
        return self._recipients

    @recipients.setter
    def recipients(self, recipients):
        """Sets the recipients of this PowerFormFormDataEnvelope.

        An array of powerform recipients.  # noqa: E501

        :param recipients: The recipients of this PowerFormFormDataEnvelope.  # noqa: E501
        :type: list[PowerFormFormDataRecipient]
        """

        self._recipients = recipients

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PowerFormFormDataEnvelope, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PowerFormFormDataEnvelope):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
