# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.  # noqa: E501

    OpenAPI spec version: v2.1
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class SignHashSessionInfoResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'documents': 'list[SignHashDocument]',
        'envelope_id': 'str',
        'language': 'str',
        'redirection_url': 'str',
        'remaining_signature_requests': 'int',
        'seal': 'Seal',
        'sender': 'Sender',
        'user': 'User'
    }

    attribute_map = {
        'documents': 'documents',
        'envelope_id': 'envelopeId',
        'language': 'language',
        'redirection_url': 'redirectionUrl',
        'remaining_signature_requests': 'remainingSignatureRequests',
        'seal': 'seal',
        'sender': 'sender',
        'user': 'user'
    }

    def __init__(self, documents=None, envelope_id=None, language=None, redirection_url=None, remaining_signature_requests=None, seal=None, sender=None, user=None):  # noqa: E501
        """SignHashSessionInfoResponse - a model defined in Swagger"""  # noqa: E501

        self._documents = None
        self._envelope_id = None
        self._language = None
        self._redirection_url = None
        self._remaining_signature_requests = None
        self._seal = None
        self._sender = None
        self._user = None
        self.discriminator = None

        if documents is not None:
            self.documents = documents
        if envelope_id is not None:
            self.envelope_id = envelope_id
        if language is not None:
            self.language = language
        if redirection_url is not None:
            self.redirection_url = redirection_url
        if remaining_signature_requests is not None:
            self.remaining_signature_requests = remaining_signature_requests
        if seal is not None:
            self.seal = seal
        if sender is not None:
            self.sender = sender
        if user is not None:
            self.user = user

    @property
    def documents(self):
        """Gets the documents of this SignHashSessionInfoResponse.  # noqa: E501

        Complex element contains the details on the documents in the envelope.  # noqa: E501

        :return: The documents of this SignHashSessionInfoResponse.  # noqa: E501
        :rtype: list[SignHashDocument]
        """
        return self._documents

    @documents.setter
    def documents(self, documents):
        """Sets the documents of this SignHashSessionInfoResponse.

        Complex element contains the details on the documents in the envelope.  # noqa: E501

        :param documents: The documents of this SignHashSessionInfoResponse.  # noqa: E501
        :type: list[SignHashDocument]
        """

        self._documents = documents

    @property
    def envelope_id(self):
        """Gets the envelope_id of this SignHashSessionInfoResponse.  # noqa: E501

        The envelope ID of the envelope status that failed to post.  # noqa: E501

        :return: The envelope_id of this SignHashSessionInfoResponse.  # noqa: E501
        :rtype: str
        """
        return self._envelope_id

    @envelope_id.setter
    def envelope_id(self, envelope_id):
        """Sets the envelope_id of this SignHashSessionInfoResponse.

        The envelope ID of the envelope status that failed to post.  # noqa: E501

        :param envelope_id: The envelope_id of this SignHashSessionInfoResponse.  # noqa: E501
        :type: str
        """

        self._envelope_id = envelope_id

    @property
    def language(self):
        """Gets the language of this SignHashSessionInfoResponse.  # noqa: E501

          # noqa: E501

        :return: The language of this SignHashSessionInfoResponse.  # noqa: E501
        :rtype: str
        """
        return self._language

    @language.setter
    def language(self, language):
        """Sets the language of this SignHashSessionInfoResponse.

          # noqa: E501

        :param language: The language of this SignHashSessionInfoResponse.  # noqa: E501
        :type: str
        """

        self._language = language

    @property
    def redirection_url(self):
        """Gets the redirection_url of this SignHashSessionInfoResponse.  # noqa: E501

          # noqa: E501

        :return: The redirection_url of this SignHashSessionInfoResponse.  # noqa: E501
        :rtype: str
        """
        return self._redirection_url

    @redirection_url.setter
    def redirection_url(self, redirection_url):
        """Sets the redirection_url of this SignHashSessionInfoResponse.

          # noqa: E501

        :param redirection_url: The redirection_url of this SignHashSessionInfoResponse.  # noqa: E501
        :type: str
        """

        self._redirection_url = redirection_url

    @property
    def remaining_signature_requests(self):
        """Gets the remaining_signature_requests of this SignHashSessionInfoResponse.  # noqa: E501

          # noqa: E501

        :return: The remaining_signature_requests of this SignHashSessionInfoResponse.  # noqa: E501
        :rtype: int
        """
        return self._remaining_signature_requests

    @remaining_signature_requests.setter
    def remaining_signature_requests(self, remaining_signature_requests):
        """Sets the remaining_signature_requests of this SignHashSessionInfoResponse.

          # noqa: E501

        :param remaining_signature_requests: The remaining_signature_requests of this SignHashSessionInfoResponse.  # noqa: E501
        :type: int
        """

        self._remaining_signature_requests = remaining_signature_requests

    @property
    def seal(self):
        """Gets the seal of this SignHashSessionInfoResponse.  # noqa: E501


        :return: The seal of this SignHashSessionInfoResponse.  # noqa: E501
        :rtype: Seal
        """
        return self._seal

    @seal.setter
    def seal(self, seal):
        """Sets the seal of this SignHashSessionInfoResponse.


        :param seal: The seal of this SignHashSessionInfoResponse.  # noqa: E501
        :type: Seal
        """

        self._seal = seal

    @property
    def sender(self):
        """Gets the sender of this SignHashSessionInfoResponse.  # noqa: E501


        :return: The sender of this SignHashSessionInfoResponse.  # noqa: E501
        :rtype: Sender
        """
        return self._sender

    @sender.setter
    def sender(self, sender):
        """Sets the sender of this SignHashSessionInfoResponse.


        :param sender: The sender of this SignHashSessionInfoResponse.  # noqa: E501
        :type: Sender
        """

        self._sender = sender

    @property
    def user(self):
        """Gets the user of this SignHashSessionInfoResponse.  # noqa: E501


        :return: The user of this SignHashSessionInfoResponse.  # noqa: E501
        :rtype: User
        """
        return self._user

    @user.setter
    def user(self, user):
        """Sets the user of this SignHashSessionInfoResponse.


        :param user: The user of this SignHashSessionInfoResponse.  # noqa: E501
        :type: User
        """

        self._user = user

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SignHashSessionInfoResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SignHashSessionInfoResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
