# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.  # noqa: E501

    OpenAPI spec version: v2.1
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class SignSessionInfoRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'certificate': 'str',
        'max_signature_length': 'str',
        'return_format': 'str',
        'signing_location': 'str'
    }

    attribute_map = {
        'certificate': 'certificate',
        'max_signature_length': 'maxSignatureLength',
        'return_format': 'returnFormat',
        'signing_location': 'signingLocation'
    }

    def __init__(self, certificate=None, max_signature_length=None, return_format=None, signing_location=None):  # noqa: E501
        """SignSessionInfoRequest - a model defined in Swagger"""  # noqa: E501

        self._certificate = None
        self._max_signature_length = None
        self._return_format = None
        self._signing_location = None
        self.discriminator = None

        if certificate is not None:
            self.certificate = certificate
        if max_signature_length is not None:
            self.max_signature_length = max_signature_length
        if return_format is not None:
            self.return_format = return_format
        if signing_location is not None:
            self.signing_location = signing_location

    @property
    def certificate(self):
        """Gets the certificate of this SignSessionInfoRequest.  # noqa: E501

          # noqa: E501

        :return: The certificate of this SignSessionInfoRequest.  # noqa: E501
        :rtype: str
        """
        return self._certificate

    @certificate.setter
    def certificate(self, certificate):
        """Sets the certificate of this SignSessionInfoRequest.

          # noqa: E501

        :param certificate: The certificate of this SignSessionInfoRequest.  # noqa: E501
        :type: str
        """

        self._certificate = certificate

    @property
    def max_signature_length(self):
        """Gets the max_signature_length of this SignSessionInfoRequest.  # noqa: E501

          # noqa: E501

        :return: The max_signature_length of this SignSessionInfoRequest.  # noqa: E501
        :rtype: str
        """
        return self._max_signature_length

    @max_signature_length.setter
    def max_signature_length(self, max_signature_length):
        """Sets the max_signature_length of this SignSessionInfoRequest.

          # noqa: E501

        :param max_signature_length: The max_signature_length of this SignSessionInfoRequest.  # noqa: E501
        :type: str
        """

        self._max_signature_length = max_signature_length

    @property
    def return_format(self):
        """Gets the return_format of this SignSessionInfoRequest.  # noqa: E501

          # noqa: E501

        :return: The return_format of this SignSessionInfoRequest.  # noqa: E501
        :rtype: str
        """
        return self._return_format

    @return_format.setter
    def return_format(self, return_format):
        """Sets the return_format of this SignSessionInfoRequest.

          # noqa: E501

        :param return_format: The return_format of this SignSessionInfoRequest.  # noqa: E501
        :type: str
        """

        self._return_format = return_format

    @property
    def signing_location(self):
        """Gets the signing_location of this SignSessionInfoRequest.  # noqa: E501

        Specifies the physical location where the signing takes place. It can have two enumeration values; InPerson and Online. The default value is Online.  # noqa: E501

        :return: The signing_location of this SignSessionInfoRequest.  # noqa: E501
        :rtype: str
        """
        return self._signing_location

    @signing_location.setter
    def signing_location(self, signing_location):
        """Sets the signing_location of this SignSessionInfoRequest.

        Specifies the physical location where the signing takes place. It can have two enumeration values; InPerson and Online. The default value is Online.  # noqa: E501

        :param signing_location: The signing_location of this SignSessionInfoRequest.  # noqa: E501
        :type: str
        """

        self._signing_location = signing_location

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SignSessionInfoRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SignSessionInfoRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
